//**************************************************************************************************
//
//  AddWorkOffsetDlg.cpp : implementation file
//
//  31MAR2008: 1) Added G59P7 to G59P12 Support
//             2) Added Configurable Start Pos G00 X and Y
//
//**************************************************************************************************
#include "stdafx.h"
#include "AddWorkOffset.h"
#include "AddWorkOffsetDlg.h"

#include "Utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//**************************************************************************************************
//
//  CAboutDlg
//  
//**************************************************************************************************
class CAboutDlg : public CDialog                                
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

//**************************************************************************************************
//
//  CAboutDlg Constructor
//  
//**************************************************************************************************
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

//**************************************************************************************************
//
//  CAboutDlg::DoDataExchange
//  
//**************************************************************************************************
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

//**************************************************************************************************
//
//  MessageMap
//  
//**************************************************************************************************
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

//**************************************************************************************************
//
//  CAddWorkOffsetDlg Constructor
//  
//**************************************************************************************************
CAddWorkOffsetDlg::CAddWorkOffsetDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CAddWorkOffsetDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CAddWorkOffsetDlg)
    m_inputFileName = _T("");
    m_bG54 = FALSE;
    m_bG55 = FALSE;
    m_bG56 = FALSE;
    m_bG57 = FALSE;
    m_bG58 = FALSE;
    m_bG59 = FALSE;
    m_bGenerateM05 = FALSE;
    m_bG59P10 = FALSE;
    m_bG59P11 = FALSE;
    m_bG59P12 = FALSE;
    m_bG59P7 = FALSE;
    m_bG59P8 = FALSE;
    m_bG59P9 = FALSE;
    m_xPosStart = 0;
    m_yPosStart = 0;
    m_bG59P13 = FALSE;
    m_bG59P14 = FALSE;
    m_bG59P15 = FALSE;
    m_bG59P16 = FALSE;
    m_bG59P17 = FALSE;
    m_bG59P18 = FALSE;
    m_bG59P19 = FALSE;
    m_bG59P20 = FALSE;
    m_bG59P21 = FALSE;
    m_bG59P22 = FALSE;
    m_bG59P23 = FALSE;
    m_bG59P24 = FALSE;
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::DoDataExchange
//  
//**************************************************************************************************
void CAddWorkOffsetDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAddWorkOffsetDlg)
    DDX_Text(pDX, IDC_FILENAME, m_inputFileName);
    DDX_Check(pDX, IDC_G54, m_bG54);
    DDX_Check(pDX, IDC_G55, m_bG55);
    DDX_Check(pDX, IDC_G56, m_bG56);
    DDX_Check(pDX, IDC_G57, m_bG57);
    DDX_Check(pDX, IDC_G58, m_bG58);
    DDX_Check(pDX, IDC_G59, m_bG59);
    DDX_Check(pDX, IDC_GENERATE_M05, m_bGenerateM05);
    DDX_Check(pDX, IDC_G59P10, m_bG59P10);
    DDX_Check(pDX, IDC_G59P11, m_bG59P11);
    DDX_Check(pDX, IDC_G59P12, m_bG59P12);
    DDX_Check(pDX, IDC_G59P7, m_bG59P7);
    DDX_Check(pDX, IDC_G59P8, m_bG59P8);
    DDX_Check(pDX, IDC_G59P9, m_bG59P9);
    DDX_Text(pDX, IDC_XPOS, m_xPosStart);
    DDX_Text(pDX, IDC_YPOS, m_yPosStart);
    DDX_Check(pDX, IDC_G59P13, m_bG59P13);
    DDX_Check(pDX, IDC_G59P14, m_bG59P14);
    DDX_Check(pDX, IDC_G59P15, m_bG59P15);
    DDX_Check(pDX, IDC_G59P16, m_bG59P16);
    DDX_Check(pDX, IDC_G59P17, m_bG59P17);
    DDX_Check(pDX, IDC_G59P18, m_bG59P18);
    DDX_Check(pDX, IDC_G59P19, m_bG59P19);
    DDX_Check(pDX, IDC_G59P20, m_bG59P20);
    DDX_Check(pDX, IDC_G59P21, m_bG59P21);
    DDX_Check(pDX, IDC_G59P22, m_bG59P22);
    DDX_Check(pDX, IDC_G59P23, m_bG59P23);
    DDX_Check(pDX, IDC_G59P24, m_bG59P24);
    //}}AFX_DATA_MAP
}

//**************************************************************************************************
//
//  MessageMap
//  
//**************************************************************************************************
BEGIN_MESSAGE_MAP(CAddWorkOffsetDlg, CDialog)
    //{{AFX_MSG_MAP(CAddWorkOffsetDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_BROWES, OnBrowes)
    ON_BN_CLICKED(IDC_G54, OnG54)
    ON_BN_CLICKED(IDC_G55, OnG55)
    ON_BN_CLICKED(IDC_G56, OnG56)
    ON_BN_CLICKED(IDC_G57, OnG57)
    ON_BN_CLICKED(IDC_G58, OnG58)
    ON_BN_CLICKED(IDC_G59, OnG59)
    ON_BN_CLICKED(IDC_GENERATE_M05, OnGenerateM05)
    ON_BN_CLICKED(IDC_G59P7, OnG59p7)
    ON_BN_CLICKED(IDC_G59P8, OnG59p8)
    ON_BN_CLICKED(IDC_G59P9, OnG59p9)
    ON_BN_CLICKED(IDC_G59P10, OnG59p10)
    ON_BN_CLICKED(IDC_G59P11, OnG59p11)
    ON_BN_CLICKED(IDC_G59P12, OnG59p12)
    ON_EN_CHANGE(IDC_XPOS, OnChangeXpos)
    ON_EN_CHANGE(IDC_YPOS, OnChangeYpos)
    ON_BN_CLICKED(IDC_G59P13, OnG59p13)
    ON_BN_CLICKED(IDC_G59P14, OnG59p14)
    ON_BN_CLICKED(IDC_G59P15, OnG59p15)
    ON_BN_CLICKED(IDC_G59P16, OnG59p16)
    ON_BN_CLICKED(IDC_G59P17, OnG59p17)
    ON_BN_CLICKED(IDC_G59P18, OnG59p18)
    ON_BN_CLICKED(IDC_G59P19, OnG59p19)
    ON_BN_CLICKED(IDC_G59P20, OnG59p20)
    ON_BN_CLICKED(IDC_G59P21, OnG59p21)
    ON_BN_CLICKED(IDC_G59P22, OnG59p22)
    ON_BN_CLICKED(IDC_G59P23, OnG59p23)
    ON_BN_CLICKED(IDC_G59P24, OnG59p24)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnInitDialog
//  
//**************************************************************************************************
BOOL CAddWorkOffsetDlg::OnInitDialog()
{
    // Call the base class
    CDialog::OnInitDialog();

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon
    
    // Restore USER settings from the last session.
    m_bG54 = AfxGetApp()->GetProfileInt( "User", "G54", 1 );
    m_bG55 = AfxGetApp()->GetProfileInt( "User", "G55", 0 );
    m_bG56 = AfxGetApp()->GetProfileInt( "User", "G56", 0 );
    m_bG57 = AfxGetApp()->GetProfileInt( "User", "G57", 0 );
    m_bG58 = AfxGetApp()->GetProfileInt( "User", "G58", 0 );
    m_bG59 = AfxGetApp()->GetProfileInt( "User", "G59", 0 );

    m_bG59P7 = AfxGetApp()->GetProfileInt( "User", "G59P7", 0 );
    m_bG59P8 = AfxGetApp()->GetProfileInt( "User", "G59P8", 0 );
    m_bG59P9 = AfxGetApp()->GetProfileInt( "User", "G59P9", 0 );
    m_bG59P10 = AfxGetApp()->GetProfileInt( "User", "G59P10", 0 );
    m_bG59P11 = AfxGetApp()->GetProfileInt( "User", "G59P11", 0 );
    m_bG59P12 = AfxGetApp()->GetProfileInt( "User", "G59P12", 0 );

    m_bG59P13 = AfxGetApp()->GetProfileInt( "User", "G59P13", 0 );
    m_bG59P14 = AfxGetApp()->GetProfileInt( "User", "G59P14", 0 );
    m_bG59P15 = AfxGetApp()->GetProfileInt( "User", "G59P15", 0 );
    m_bG59P16 = AfxGetApp()->GetProfileInt( "User", "G59P16", 0 );
    m_bG59P17 = AfxGetApp()->GetProfileInt( "User", "G59P17", 0 );
    m_bG59P18 = AfxGetApp()->GetProfileInt( "User", "G59P18", 0 );

    m_bG59P19 = AfxGetApp()->GetProfileInt( "User", "G59P19", 0 );
    m_bG59P20 = AfxGetApp()->GetProfileInt( "User", "G59P20", 0 );
    m_bG59P21 = AfxGetApp()->GetProfileInt( "User", "G59P21", 0 );
    m_bG59P22 = AfxGetApp()->GetProfileInt( "User", "G59P22", 0 );
    m_bG59P23 = AfxGetApp()->GetProfileInt( "User", "G59P23", 0 );
    m_bG59P24 = AfxGetApp()->GetProfileInt( "User", "G59P24", 0 );

    m_xPosStart = AfxGetApp()->GetProfileInt( "User", "Xpos", 0 );
    m_yPosStart = AfxGetApp()->GetProfileInt( "User", "Ypos", 0 );

    m_bGenerateM05 = AfxGetApp()->GetProfileInt( "User", "M05", 1 );

    m_inputFileName = AfxGetApp()->GetProfileString( "User", "PathName" );

    UpdateData( FALSE );
    
    return TRUE;  
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnSysCommand
//  
//**************************************************************************************************
void CAddWorkOffsetDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnPaint
//  
//**************************************************************************************************
void CAddWorkOffsetDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnQueryDragIcon
//  
//**************************************************************************************************
HCURSOR CAddWorkOffsetDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnBrowes() 
//
//  Select the input file name to add workoffsets to
//  
//**************************************************************************************************
void CAddWorkOffsetDlg::OnBrowes() 
{
    // Initialize the dialog.
    CFileDialog fileDlg( TRUE );

    // Get our last settings.
    CString LastPath = AfxGetApp()->GetProfileString( "User", "PathName" );
    CString LastName = AfxGetApp()->GetProfileString( "User", "FileName" );

    char lastName[ 500 ];
    strcpy( lastName, LastName );
    fileDlg.m_ofn.lpstrInitialDir = LastPath;
    fileDlg.m_ofn.lpstrFile = lastName;
    fileDlg.m_ofn.lpstrTitle = "Select a NC/TAP File";
    fileDlg.m_ofn.lpstrFilter = "NC File (*.NC)\0*.nc\0TAP File (*.TAP)\0*.tap\0";

    // Display the File Select Dialoag and Check for a cancel button.
    if( fileDlg.DoModal() == IDCANCEL )
        return;

    // Save the information for next time.
    AfxGetApp()->WriteProfileString( "User", "PathName", fileDlg.GetPathName() );
    AfxGetApp()->WriteProfileString( "User", "FileName", fileDlg.GetFileName() );

    // Get the file parameters.
    m_inputFileName = fileDlg.GetPathName();

    // Update the GUI
    UpdateData( FALSE );
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::addWorkOffset
//  
//  Once a TOOL Change is detected, this does the work of adding the Work Offsets
//  
//**************************************************************************************************
void CAddWorkOffsetDlg::addWorkOffset( CStdioFile* outFile, CString& fileBuffer )
{
    CString offsetText;

    // Loop on each offset
    for( int offset = 1; offset <= 24 ; offset++ )
    {
        bool process = FALSE;
        switch( offset )
        {
        case  1: if(  m_bG54 )   process = TRUE; offsetText = "G54"; break;
        case  2: if(  m_bG55 )   process = TRUE; offsetText = "G55"; break;
        case  3: if(  m_bG56 )   process = TRUE; offsetText = "G56"; break;
        case  4: if(  m_bG57 )   process = TRUE; offsetText = "G57"; break;
        case  5: if(  m_bG58 )   process = TRUE; offsetText = "G58"; break;
        case  6: if(  m_bG59 )   process = TRUE; offsetText = "G59"; break;

        case  7: if(  m_bG59P7 ) process = TRUE; offsetText =  "G59P7"; break;
        case  8: if(  m_bG59P8 ) process = TRUE; offsetText =  "G59P8"; break;
        case  9: if(  m_bG59P9 ) process = TRUE; offsetText =  "G59P9"; break;
        case 10: if( m_bG59P10 ) process = TRUE; offsetText = "G59P10"; break;
        case 11: if( m_bG59P11 ) process = TRUE; offsetText = "G59P11"; break;
        case 12: if( m_bG59P12 ) process = TRUE; offsetText = "G59P12"; break;

        case 13: if( m_bG59P13 ) process = TRUE; offsetText = "G59P13"; break;
        case 14: if( m_bG59P14 ) process = TRUE; offsetText = "G59P14"; break;
        case 15: if( m_bG59P15 ) process = TRUE; offsetText = "G59P15"; break;
        case 16: if( m_bG59P16 ) process = TRUE; offsetText = "G59P16"; break;
        case 17: if( m_bG59P17 ) process = TRUE; offsetText = "G59P17"; break;
        case 18: if( m_bG59P18 ) process = TRUE; offsetText = "G59P18"; break;

        case 19: if( m_bG59P19 ) process = TRUE; offsetText = "G59P19"; break;
        case 20: if( m_bG59P20 ) process = TRUE; offsetText = "G59P20"; break;
        case 21: if( m_bG59P21 ) process = TRUE; offsetText = "G59P21"; break;
        case 22: if( m_bG59P22 ) process = TRUE; offsetText = "G59P22"; break;
        case 23: if( m_bG59P23 ) process = TRUE; offsetText = "G59P23"; break;
        case 24: if( m_bG59P24 ) process = TRUE; offsetText = "G59P24"; break;
        }

        // Should we process this offset.
        if( process )
        {
            // Add Comment
            CString tempBuffer;
            tempBuffer.Format( "(--- %s Work Offset Was Added ---)\n", offsetText );
            outFile->WriteString( tempBuffer );

            // Machine Home the Z Axis
            outFile->WriteString( "G00 G53 Z0\n" );

            // Write out the WorkOffset Code
            tempBuffer.Format( "%s\n", offsetText );
            outFile->WriteString( tempBuffer );

            // Move to the Start X and Start Y of the New WorkOffset
            tempBuffer.Format( "G00 X%d Y%d\n", m_xPosStart, m_yPosStart );
            outFile->WriteString( tempBuffer );

            // Mark the end of the modifications
            outFile->WriteString( "(---------------------------------)\n" );

            // Dump the Buffer
            outFile->WriteString( fileBuffer );

        }
    }
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnOK
//
//  Start up the Add Offset Engine
//  
//**************************************************************************************************
void CAddWorkOffsetDlg::OnOK() 
{
    // Make sure we have the current settings
    UpdateData();

    // Make sure we have at least one offset checked.
    if( ! (   m_bG54 ||     m_bG55 ||    m_bG56 ||    m_bG57 ||    m_bG58 ||    m_bG59 ||
            m_bG59P7 ||   m_bG59P8 ||  m_bG59P9 || m_bG59P10 || m_bG59P11 || m_bG59P12 ||
            m_bG59P13 || m_bG59P14 || m_bG59P15 || m_bG59P15 || m_bG59P16 || m_bG59P17 ))
    {
        MessageBox( "Please select at least one work offset" );
        return;
    }

    // Attempt to Open the File.
    CStdioFile inFile;
    if( ! inFile.Open( m_inputFileName, CFile::modeRead ))
    {
        MessageBox( "Failed to open input file" );
        return;
    }

    // Create the new fileName
    CString outFileName;
    if( m_bG54 )    outFileName += "G54_";
    if( m_bG55 )    outFileName += "G55_";
    if( m_bG56 )    outFileName += "G56_";
    if( m_bG57 )    outFileName += "G57_";
    if( m_bG58 )    outFileName += "G58_";
    if( m_bG59 )    outFileName += "G59_";

    if( m_bG59P7 )  outFileName += "G59P7_";
    if( m_bG59P8 )  outFileName += "G59P8_";
    if( m_bG59P9 )  outFileName += "G59P9_";
    if( m_bG59P10 ) outFileName += "G59P10_";
    if( m_bG59P11 ) outFileName += "G59P11_";
    if( m_bG59P12 ) outFileName += "G59P12_";

    if( m_bG59P13 ) outFileName += "G59P13_";
    if( m_bG59P14 ) outFileName += "G59P14_";
    if( m_bG59P15 ) outFileName += "G59P15_";
    if( m_bG59P16 ) outFileName += "G59P16_";
    if( m_bG59P17 ) outFileName += "G59P17_";
    if( m_bG59P18 ) outFileName += "G59P18_";

    if( m_bG59P19 ) outFileName += "G59P19_";
    if( m_bG59P20 ) outFileName += "G59P20_";
    if( m_bG59P21 ) outFileName += "G59P21_";
    if( m_bG59P22 ) outFileName += "G59P22_";
    if( m_bG59P23 ) outFileName += "G59P23_";
    if( m_bG59P24 ) outFileName += "G59P24_";

    CString outFilePath =  GetDrive( m_inputFileName ) + 
                           //"\" +
                           GetDirectory( m_inputFileName ) +
                           outFileName + 
                           GetFile( m_inputFileName ) + 
                           GetExt( m_inputFileName );

    TRACE( "Output File Name: '%s'\n", outFilePath );

    // Create the output file
    CStdioFile outFile;
    if( ! outFile.Open( outFilePath, CFile::modeWrite | CFile::modeCreate ))
    {
        MessageBox( "Failed to create/open output file" );
        return;
    }

    // Process each line of the file.
    CString lineOfData;
    CString fileBuffer;
    bool firstTool = TRUE;
    while( inFile.ReadString( lineOfData ))
    {
        // TRACE( "'%s'\n", lineOfData );

        // Is this a tool change?
        if( lineOfData.Find( "M06" ) >= 0 )
        {
            // TRACE( "TOOL: '%s'\n", lineOfData );

            // First tool special case
            if( firstTool )
            {
                // Dump the header only once, not for each work offset
                firstTool = FALSE;
                outFile.WriteString( fileBuffer );
                fileBuffer = "";

                // Dump out the tool change line of code
                outFile.WriteString( lineOfData );
                outFile.WriteString( "\n" );
            }
            else
            {
                // Insert the work Offset
                addWorkOffset( &outFile, fileBuffer );

                // Dump out the optional M05 before each tool change
                if( m_bGenerateM05 )
                {
                    outFile.WriteString( "(--- M05 Was Added ---------------)\n" );
                    outFile.WriteString( "M05\n" );
                    outFile.WriteString( "(---------------------------------)\n" );
                }

                // Dump out the tool change line of code
                outFile.WriteString( lineOfData );
                outFile.WriteString( "\n" );

                fileBuffer = "";
            }
        }

        // Look for the Magic M500 (ie: Reclamp Opperation)
        else if( lineOfData.Find( "(M500)" ) >= 0 )
        {
            // Signal Mach3 to move the part to the user for a clamp opperation
            // fileBuffer += "M500\n";
        }

        // Eat the M05
        else if( lineOfData.Find( "M05" ) >= 0 )
        {
            
        }

        // Is this the end of the program
        else if( lineOfData.Find( "M30" ) >= 0 )
        {
            // Insert the work Offset
            addWorkOffset( &outFile, fileBuffer );

            // Dump out the M05
            outFile.WriteString( "M05\n" );

            // Dump out the M30
            outFile.WriteString( lineOfData );

            // Dump out the End Of File Marker
            outFile.WriteString( "\n%\n" );

            // Stop processing
            MessageBox( "Work Offsets have been successfully added" );
            return;
        }
        else
        {
            // Add to the buffer
            fileBuffer += lineOfData + "\n";
        }
    }
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::Offset
//
//**************************************************************************************************
void CAddWorkOffsetDlg::OnCancel() 
{
    // Close up the dialog
    CDialog::OnCancel();
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnG54 - OnG59
//
//  Save off the settings for next time...
//
//**************************************************************************************************
void CAddWorkOffsetDlg::OnG54() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G54", m_bG54 );
}

void CAddWorkOffsetDlg::OnG55() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G55", m_bG55 );
}

void CAddWorkOffsetDlg::OnG56() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G56", m_bG56 );
}

void CAddWorkOffsetDlg::OnG57() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G57", m_bG57 );
}

void CAddWorkOffsetDlg::OnG58() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G58", m_bG58 );
}

void CAddWorkOffsetDlg::OnG59() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59", m_bG59 );
}

void CAddWorkOffsetDlg::OnG59p7() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P7", m_bG59P7 );
}

void CAddWorkOffsetDlg::OnG59p8() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P8", m_bG59P8 );
}

void CAddWorkOffsetDlg::OnG59p9() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P9", m_bG59P9 );
}

void CAddWorkOffsetDlg::OnG59p10() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P10", m_bG59P10 );
}

void CAddWorkOffsetDlg::OnG59p11() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P11", m_bG59P11 );
}

void CAddWorkOffsetDlg::OnG59p12() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P12", m_bG59P12 );
}

void CAddWorkOffsetDlg::OnG59p13() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P13", m_bG59P13 );
}

void CAddWorkOffsetDlg::OnG59p14() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P14", m_bG59P14 );
}

void CAddWorkOffsetDlg::OnG59p15() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P15", m_bG59P15 );
}

void CAddWorkOffsetDlg::OnG59p16() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P16", m_bG59P16 );
}

void CAddWorkOffsetDlg::OnG59p17() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P17", m_bG59P17 );
}

void CAddWorkOffsetDlg::OnG59p18() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P18", m_bG59P18 );
}

void CAddWorkOffsetDlg::OnG59p19() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P19", m_bG59P19 );
}

void CAddWorkOffsetDlg::OnG59p20() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P20", m_bG59P20 );
}

void CAddWorkOffsetDlg::OnG59p21() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P21", m_bG59P21 );
}

void CAddWorkOffsetDlg::OnG59p22() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P22", m_bG59P22 );
}

void CAddWorkOffsetDlg::OnG59p23() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P23", m_bG59P23 );
}

void CAddWorkOffsetDlg::OnG59p24() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59P24", m_bG59P24 );
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnGenerateM05
//
//**************************************************************************************************
void CAddWorkOffsetDlg::OnGenerateM05() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "M05", m_bGenerateM05 );
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnChangeXpos OnChangeYpos
//
//**************************************************************************************************
void CAddWorkOffsetDlg::OnChangeXpos() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "Xpos", m_xPosStart );
}

void CAddWorkOffsetDlg::OnChangeYpos() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "Ypos", m_yPosStart );
}

